<!--
 Copyright (C) 2024 bAvenir

 This program and the accompanying materials are made
 available under the terms of the Eclipse Public License 2.0
 which is available at https://www.eclipse.org/legal/epl-2.0/

 SPDX-License-Identifier: EPL-2.0
-->

<div class="w-[1200px] h-[580px]">
  <app-menu type="vertical">
    <app-menu-item>
      <app-menu-label>
        <div class="flex gap-2 text-base font-semibold items-center justify-start">
          <div class="text-text-500">All</div>
        </div>
      </app-menu-label>
      <app-menu-content>
        <div class="pl-4 h-full flex flex-col gap-4">
          <div class="shrink-0">
            <input
              pInputText
              [(ngModel)]="searchAllText"
              (input)="searchAll($event)"
              placeholder="Search..."
              [style]="{ width: '200px' }"
            />
          </div>
          <div class="grow overflow-y-auto">
            <div class="grid grid-cols-1 sm:grid-cols-2 lg:grid-cols-3 gap-0.5">
              <ng-container *ngFor="let type of allFilteredTypes$ | async">
                <div
                  class="flex items-center gap-2 cursor-pointer py-2 px-2 hover:bg-primary-100 rounded-sm h-fit"
                  [pTooltip]="type.mime"
                  tooltipPosition="left"
                  (click)="selectType(type.mime)"
                >
                  <div class="cursor-pointer flex items-center gap-2">
                    <i [class]="type.icon"></i>
                    <div class="max-w-56 break-words truncate">{{ type.mime }}</div>
                  </div>
                </div>
              </ng-container>
            </div>
          </div>
        </div>
      </app-menu-content>
    </app-menu-item>
    <app-menu-item *ngFor="let mimeGroup of mimeTypes | keyvalue">
      <app-menu-label>
        <div class="flex gap-2 text-base font-semibold items-center justify-start">
          <div class="w-5">
            <i [class]="mimeGroup.value.icon"></i>
          </div>
          <div class="text-text-500">{{ mimeGroup.key | titlecase }}</div>
        </div>
      </app-menu-label>
      <app-menu-content>
        <div class="pl-4 h-full flex flex-col gap-4">
          <div class="shrink-0">
            <input
              pInputText
              [(ngModel)]="searchGroupText"
              (input)="searchGroup($event, mimeGroup.key)"
              placeholder="Search..."
              [style]="{ width: '200px' }"
            />
          </div>
          <div class="shrink-0 grow overflow-y-auto">
            <div class="grid grid-cols-1 sm:grid-cols-2 lg:grid-cols-3 gap-0.5 h-fit">
              <ng-container *ngFor="let type of groupFilteredTypes[mimeGroup.key] | async">
                <div
                  class="flex items-center gap-2 cursor-pointer py-2 px-2 hover:bg-primary-100 rounded-sm h-fit"
                  [pTooltip]="type.mime"
                  tooltipPosition="left"
                  (click)="selectType(type.mime)"
                >
                  <div class="cursor-pointer flex items-center gap-2">
                    <i [class]="type.icon"></i>
                    <div class="max-w-56 break-words truncate">{{ type.mime }}</div>
                  </div>
                </div>
              </ng-container>
            </div>
          </div>
        </div>
      </app-menu-content>
    </app-menu-item>
    <app-menu-item>
      <app-menu-label>
        <div class="flex gap-2 text-base font-semibold items-center justify-start">
          <div class="w-5">
            <i class="fa fa-gears"></i>
          </div>
          <div class="text-text-500">Custom</div>
        </div>
      </app-menu-label>
      <app-menu-content>
        <form class="pl-4 h-full w-full flex flex-col items-center justify-center" (submit)="selectType(customMimeType.value)">
          <div class="text-md font-semibold pb-4">Custom MIME type</div>
          <div class="pb-8 text-text-300">Please specify the custom MIME type</div>
          <div class="pb-8 flex flex-col items-center gap-8">
            <input
              pInputText
              [formControl]="customMimeType"
              placeholder="Custom MIME type name"
              [style]="{ width: '200px' }"
            />
            <app-info message="Custom MIME type will be recognized as a file type in UI"></app-info>
          </div>
          <p-button
            label="Confirm"
            [disabled]="(customMimeType.statusChanges | async) != 'VALID'"
            (onClick)="selectType(customMimeType.value)"
          ></p-button>
        </form>
      </app-menu-content>
    </app-menu-item>
  </app-menu>
</div>
